/*
 * File:	myComponent.cpp
 *
 * A Simple Example--Authentication Component.
 * 	To Create a Component which works with the InterfaceServer,
 *  the interface ComponentBase is required to be implemented.
 * 	interface ComponentBase is described in interface.cpp/h
 *
 * Author:	Chirag Vaidya   (cvaidya@cs.pitt.edu)
 *
 * Last changed: March 1, 2004
 *
 */

#include "myComponent.h"
#include <string.h>
#include <errno.h>
#include <fcntl.h>

const int myComponent::init = 0;
const int myComponent::success = 1;
const int myComponent::failure = 2;

myComponent::myComponent()
{
	state = init;
}

void myComponent::doAuthentication( string first, string last, string passwd )
{
	if( first == "chirag" && last == "vaidya" &&
			passwd == "chigs" )
		state = success;
	else
		state = failure;
}

KeyValueList* myComponent::processMsg( KeyValueList kvList )
{
	int msgId;
	string	tmpStr;
	
	tmpStr = kvList.getValue("MsgID");
	sscanf( tmpStr.c_str(), "%d", &msgId );
	//tmpStr >> msgId;

	if( msgId != 0 ) 
		return NULL;

	doAuthentication( kvList.getValue("FirstName"),
			kvList.getValue("LastName"), kvList.getValue("passwd"));

	KeyValueList *pKvResult = new KeyValueList();
	pKvResult->addPair("MsgID","1");
	pKvResult->addPair("Description","Authentication Result");
       
	switch (state)
	{
	case success:
		pKvResult->addPair("Authentication","success");
		break;
	
	case failure: 
		pKvResult->addPair("Authentication","failure");	
		break;

	default:
		//throw exception;
		break;
	}; 
	return pKvResult;   	
}


